
Public Class clsSounds

    'Define function for sounds - API call
    Private Declare Function PlaySound Lib "winmm.dll" Alias "PlaySoundA" (ByVal lpszName As String, ByVal hModule As Long, ByVal dwFlags As Long) As Long
    Private lngret As Long

    '  Wav .
    Dim FileWave As WaveFile

    '--- /  --------------------------

    '     ( clsSound)
    Private items As ArrayList

    '-------------------------------------------
    '-------------------------------

    '    ; 
    Public ReadOnly Property CountSounds%()
        Get
            Return items.Count
        End Get
    End Property

    '------------------------
    '-------------------------------
    '.
    Public Sub New()
        items = New ArrayList()
        FileWave = New WaveFile()
    End Sub
    '-------------------------------
    '.
    Public Sub Clear()
        items.Clear()
    End Sub
    '-------------------------------
    '        .
    Public Function GetSoundIndex%(ByVal descr$)

        Dim i% = 0, breqike As Boolean = False
        Dim snd As New clsSound()
        Try
            '    .
            While (i <= CountSounds - 1) And (Not breqike)
                snd = items(i)
                If snd.Description = descr Then
                    breqike = True
                Else
                    i += 1
                End If
            End While
        Catch
            Return -1
        End Try
        snd = Nothing

        If breqike Then Return i Else Return -1

    End Function
    '-------------------------------
    '     indexSound.   -1   nothing.
    Public Function GetSound(ByVal indexSound%) As clsSound
        Try
            If indexSound >= 0 Then Return items(indexSound) Else Return Nothing
        Catch
            Return Nothing
        End Try
    End Function
    '-------------------------------
    '.      .   -1   nothing.
    Public Function GetSound(ByVal Description$) As clsSound

        Dim i%
        Try
            i = GetSoundIndex(Description)
            If i >= 0 Then Return items(i) Else Return Nothing
        Catch
            Return Nothing
        End Try
    End Function
    '-------------------------------
    '    .
    Public Function AddSound(ByVal newSound As clsSound) As Boolean
        Try
            items.Add(newSound)
            Return True
        Catch
            Return False
        End Try
    End Function
    '-------------------------------
    ' .   indexSound     UpdSound  
    '    .
    Public Function UpdateSound(ByVal UpdSound As clsSound, ByVal IndexSound%) As Boolean
        Try
            items(IndexSound) = UpdSound
            Return True
        Catch
            Return False
        End Try
    End Function
    '-------------------------------
    '  i . 
    Public Function DeleteSound(ByVal indexSound%) As Boolean
        Try
            items.RemoveAt(indexSound)
            Return True
        Catch
            Return False
        End Try
    End Function
    '-------------------------------
    '  ArrayList    Bubble Sort.
    Public Function SortSounds(ByVal fld$) As Boolean
        Dim i%, j%
        Dim n% = CountSounds - 1
        Dim tmp As New clsSound()
        Try
            For i = 0 To n - 1
                For j = n To i + 1 Step -1
                    If items(j - 1).GetValue(fld) > items(j).GetValue(fld) Then
                        tmp = items(j - 1)
                        items(j - 1) = items(j)
                        items(j) = tmp
                    End If
                Next
            Next
            Return True
        Catch
            Return False
        Finally
            tmp = Nothing
        End Try

    End Function
    '-------------------------------
    ' 
    Public Sub PlaySound(ByVal Description$)
        On Error Resume Next

        'stop previous sound
        'lngret = PlaySound(vbNullString, 0, &H0)
        '-----------------
        'play
        'lngret = PlaySound(GetSound(Description).FilePath, 0, &H0)

        '       .
        If (Not (FileWave Is Nothing)) Then '  And FileWave.Playing Then
            FileWave.StopPlay()
            FileWave = Nothing
        End If
        ' 
        FileWave = New WaveFile(GetSound(Description).FilePath)
        FileWave.Play()

    End Sub
    '-------------------------------
    '.  
    Public Sub PlaySound(ByVal indexSound%)
        On Error Resume Next

        'stop previous sound
        'lngret = PlaySound(vbNullString, 0, &H0)
        '-----------------
        'play
        'lngret = PlaySound(GetSound(indexSound).FilePath, 0, &H0)
        PlaySound(GetSound(indexSound).Description)

    End Sub
    '-------------------------------
    Public Sub StopSound()
        On Error Resume Next

        'stop previous sound
        'lngret = PlaySound(vbNullString, 0, &H0)
        '-----------------
        'play
        'lngret = PlaySound(GetSound(Description).FilePath, 0, &H0)

        '       .
        If (Not (FileWave Is Nothing)) Then '  And FileWave.Playing Then
            FileWave.StopPlay()
            FileWave = Nothing
        End If
    End Sub
    '-------------------------------
    Public Function IsPlaying() As Boolean
        On Error Resume Next

        '       .
        If FileWave Is Nothing Then Return False

        IsPlaying = IIf(FileWave.Playing, True, False)
    End Function
    '-------------------------------
End Class
